.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include MenuTest.inc

.code

;########################################################################

MakeBitMap proc uses esi edi,barcolor:DWORD,bodycolor:DWORD
	LOCAL	hBmp:DWORD
	LOCAL	hDC:DWORD
	LOCAL	hMemDC:DWORD
	LOCAL	hDeskTop:DWORD

	invoke GetDesktopWindow
	mov hDeskTop,eax
	invoke GetDC,hDeskTop
	mov hDC,eax
	invoke CreateCompatibleDC,hDC
	mov hMemDC,eax
	invoke CreateCompatibleBitmap,hDC,600,8
	mov hBmp,eax
	invoke ReleaseDC,hDeskTop,hDC
	invoke SelectObject,hMemDC,hBmp
	push eax
	xor esi,esi
	.while esi<8
		xor edi,edi
		.WHILE edi<16
			invoke SetPixel,hMemDC,edi,esi,barcolor
			inc edi
		.ENDW
		.WHILE edi<600
			invoke SetPixel,hMemDC,edi,esi,bodycolor
			inc edi
		.ENDW
		inc esi
	.endw
	pop eax
	invoke SelectObject,hMemDC,eax
	invoke DeleteDC,hMemDC
	mov eax,hBmp
	ret

MakeBitMap endp

CoolMenu proc uses edi,hMnu:DWORD,BarColor:DWORD,BodyColor:DWORD
	LOCAL	MInfo:MENUINFO

	invoke MakeBitMap,BarColor,BodyColor
	push	eax
	invoke CreatePatternBrush,eax
	mov hMenuBrush,eax
	mov MInfo.hbrBack,eax
	mov MInfo.cbSize,SIZEOF MENUINFO
	mov MInfo.fmask,MIM_BACKGROUND or MIM_APPLYTOSUBMENUS
	xor edi,edi
  @@:
	invoke GetSubMenu,hMnu,edi
	.if eax
		mov edx,eax
		invoke SetMenuInfo,edx,ADDR MInfo
		inc edi
		jmp @b
	.endif
	pop		eax
	invoke DeleteObject,eax
	ret

CoolMenu endp

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke GetMenu,hWin
		invoke CoolMenu,eax,0c0c0ffh,0ffffffh
	.elseif eax==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==10002
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke DeleteObject,hMenuBrush
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

;########################################################################

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

end start
